package HexToBinary;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.UIManager;


public class Main extends javax.swing.JFrame {
    
    private File file;

    /**
     * Creates new form GUI
     */
    public Main() {
        // default output file
        file = new File("out.b");
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        textArea = new javax.swing.JTextArea();
        saveButton = new javax.swing.JButton();
        convertButton = new javax.swing.JButton();
        outputLabel = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Hex to Binary");
        setMinimumSize(new java.awt.Dimension(316, 313));
        setName("hexToBin"); // NOI18N
        setPreferredSize(new java.awt.Dimension(317, 314));
        setSize(new java.awt.Dimension(316, 313));

        textArea.setColumns(20);
        textArea.setRows(5);
        textArea.setName("textArea"); // NOI18N
        textArea.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                Main.this.keyReleased(evt);
            }
        });
        jScrollPane1.setViewportView(textArea);

        saveButton.setText("Select Output");
        saveButton.setMaximumSize(new java.awt.Dimension(89, 25));
        saveButton.setMinimumSize(new java.awt.Dimension(89, 25));
        saveButton.setName("saveButton"); // NOI18N
        saveButton.setPreferredSize(new java.awt.Dimension(89, 25));
        saveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveButtonActionPerformed(evt);
            }
        });

        convertButton.setText("Convert");
        convertButton.setToolTipText("");
        convertButton.setEnabled(false);
        convertButton.setName("convertButton"); // NOI18N
        convertButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                convertButtonActionPerformed(evt);
            }
        });

        outputLabel.setText(file.getName());
        outputLabel.setName("outputLabel"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(14, 14, 14)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(saveButton, javax.swing.GroupLayout.PREFERRED_SIZE, 104, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(outputLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 87, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(convertButton, javax.swing.GroupLayout.PREFERRED_SIZE, 89, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jScrollPane1))
                .addGap(14, 14, 14))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGap(14, 14, 14)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 242, Short.MAX_VALUE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(saveButton, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(convertButton, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(outputLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(14, 14, 14))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void saveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveButtonActionPerformed
        JFileChooser fileDialog = new JFileChooser(System.getProperty("user.dir"));
        fileDialog.setDialogTitle("Output file");
        fileDialog.showSaveDialog(this);
        File newFile = fileDialog.getSelectedFile();

        if (newFile != null) {
            file = newFile;
            outputLabel.setText(file.getName());
            convertButton.setText("Convert");
        }
    }//GEN-LAST:event_saveButtonActionPerformed

    private void keyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_keyReleased
    convertButton.setEnabled(!textArea.getText().isEmpty());
    }//GEN-LAST:event_keyReleased

    private void convertButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_convertButtonActionPerformed
        String text = textArea.getText();

        //transform hex string for logic circuit
        text = text.replaceAll("[\t ]", "");
        String[] hexs = text.split("\n");
        for(int i = 0; i < hexs.length; i++) {
            if(hexs[i].length() == 8) {
                hexs[i] = reorder(hexs[i]);
            } else {
                showAlert(
                        "Hex Length Alert",
                        "Wrong length",
                        "Line " + (i + 1) + " of hex needs to be 8 characters long"
                );
                return;
            }
        }

        String hexString = String.join("", hexs);

        try(OutputStream stream = new BufferedOutputStream(new FileOutputStream(file))) {
            stream.write(hexStringToByteArray(hexString));
            stream.close();
            convertButton.setText("Converted");
        } catch (IOException e) {
            showAlert(
                    "Saving Error",
                    "Error saving file",
                    e.getMessage()
            );
        }
    }//GEN-LAST:event_convertButtonActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch(ClassNotFoundException | InstantiationException | IllegalAccessException | javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Main.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Main().setVisible(true);
            }
        });
    }
    
    /**
     * Reorder the hex string so that it works with logic circuit
     * This reverses the string, then reverses char 0 & 1, 2 & 3, etc.
     * @param hex   The hex string to reorder
     * @return      The reordered hex string
     */
    private String reorder(String hex) {
        char[] temp = new char[8];
        temp[0] = hex.charAt(6);
        temp[1] = hex.charAt(7);
        temp[2] = hex.charAt(4);
        temp[3] = hex.charAt(5);
        temp[4] = hex.charAt(2);
        temp[5] = hex.charAt(3);
        temp[6] = hex.charAt(0);
        temp[7] = hex.charAt(1);

        return new String(temp);
    }

    /**
     * Converts hex string to a byte array
     * http://stackoverflow.com/a/140861/1303986
     * @param s     The hex string to convert
     * @return      The byte array
     */
    private byte[] hexStringToByteArray(String s) {
        int len = s.length();
        byte[] data = new byte[len / 2];
        for (int i = 0; i < len; i += 2) {
            data[i / 2] = (byte) ((Character.digit(s.charAt(i), 16) << 4)
                    + Character.digit(s.charAt(i+1), 16));
        }
        return data;
    }

    /**
     * Show alert to user
     * @param title     The title of the alert
     * @param header    The header of the alert
     * @param content   The content of the alert
     */
    private void showAlert(String title, String header, String content) {
        JOptionPane.showMessageDialog(this, header + " - " + content, title, JOptionPane.ERROR_MESSAGE);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton convertButton;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel outputLabel;
    private javax.swing.JButton saveButton;
    private javax.swing.JTextArea textArea;
    // End of variables declaration//GEN-END:variables
}
